#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Icon.ico
#AutoIt3Wrapper_Outfile=..\Tur-Matcher.exe
#AutoIt3Wrapper_Res_Description=Tur-Matcher
#AutoIt3Wrapper_Res_LegalCopyright=Turranius (c) 2016
#AutoIt3Wrapper_Res_Fileversion=1.13
#AutoIt3Wrapper_Res_ProductVersion=1.13.0
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <File.au3>
#include <Typos.au3>
#include <Array.au3>
#include <GuiListView.au3>
#include <String.au3>

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <WindowsConstants.au3>
#include <ListviewConstants.au3>
#include <ColorConstants.au3>

#cs
	1.0
	* Initial release.
	1.1
	* Remove any non ASCII chars from cleaned up name. Improves match percentage.
	* Replace II with 2 etc, Up to 8. Improves match percentage.
	* Rewritten some comparison parts for a little speed upgrade. Not much though.
	* It wont ask for any user input until the end when everything is matched up.
	1.2
	* If a direct match is found, that source is removed from the array so it is not matched
	with again. Improves speed by a lot if the sourcefiles have a lot of 0 mispelled items.
	* Dupes will not be added to the source array. No reason to check the same file more then once.
	1.3
	* Now logs everything to a Logs subdir. TAB separated lists so just open them in Excel or similar.
	* You can now specify a folder full of directories as source as well. Good for artwork and similar
	that expects the files to be inside folders named after the roms/XML.
	1.4
	* Also translates &apos; to ' when reading the XML.
	1.5
	* Replaces _ with a space.
	* Replaces ' & ' with ' and '
	* Replaces ' the ' with ' '
	* Replaces '' with 'u'
	* Added traytip when its scanning source names and media so you know its not hung on really large sets. Just hover over icon.
	* Save last used settings in Tur-Matcher.ini so it defaults to the same on the next run.
	* New setting in config file, SourcesToSplit. Default is 10000. If your source media dir contains more then this amount
	of files, the array it creates to search from is split into the alphabet. Any source names will only search in the
	array that corresponds to its starting letter, greatly increasing speed if you have a LOT of source file.
	It might also mean it will miss a match if they do not share a common starting letter.
	* If the Source Name have the same name (multiple disks for example), then it will only match the first hit and reuse
	the results for the next one(s). No need to do the same search twice, or more, in a row.
	1.6
	* You now have the option to move the source media instead of copying it. An extra check if its possible will be executed if
	you select to move.
	* Fixed saving Tur-Matcher.ini if you use an XML file. It would write the ini file in the XML file location. Oops.
	1.7
	* Added a GUI to it instead of the questions at the start. Makes it feel a bit more professional IMO.
	* Removed all the traytips. Its showing in the GUI now. Besides, it kinda crashed explorer on my Windows 10 machine...
	* Fixed a problem. If the first sourcefile was found to be a match for something, it was not found to be an actual match. Thanks autoit, not.
	* The last array displayed, that which showed unmatched sources, only showed those that found a partial match. It now also shows those that found
	no match at all, with "NA" as its matched content.
	1.8
	* Added a GUI instead of all the questions for "Do these match" at the end.
	* Also shows a GUI for the stuff that was not a match, incase you want to go through them anyway.
	* When using a XML as SourceNames, it stripped the "&" sign, causing unneeded mispellings. Now changes it to "and" instead when cleaning up, same
	as is done for the sources containing an & sign.
	1.9
	* Added a checkbox to the GUI to not show the 3 arrays before starting perfect match copy.
	* Switched the direct hits and partial hits number selection in the GUI around. Makes more sense now IMO.
	1.10
	* The Browse button for Destination will now take you to the same directory as "Source files", if its set and "Destination" is not.
	* The status for the "Do not show result windows" checkbox is now saved in the INI file so it will remember your choice.
	* If the Destination folder does not exist, it will ask if you want to create it when clicking "Start".
	* Cleaned up some error checking when clicking "Start". It'll check that all seems correct now.
	* Added a "Reset to Default" button to clear everything back to default values.
	1.11
	* The fix in 1.8 to change "&" to "and" in the XML was actually done in the real name (decides final name) instead of the cleaned name (only used for
	matching). This caused the final file to get the wrong name. Now changed. Thanks vaderag for the report =)
	1.12
	* You can now check "Handle different disks" on the main menu. This will try to keep things like (Disk 1), (Disc 1), (Tape 1) and (Cart 1) seperate.
	* Fixed a tiny bug. If you have more then 10000 source files (default), it will split them up into different arrays depending on the first char of the
	name, but it would skip anything that did not start with A-Z and 0-9. If a sourcefile started with $ for example, it would not be matched.
	1.13
	* Ability to strip a number of chars from the sourcenames. Both from the start and from the end.
	I wanted to match a Nintendo DS set where the roms were called "0001 - Electroplankton (Japan).nds", etc. The numbering at the start messed the
	matching up. It would still work but take a lot longer and give me 5-7 spelling errors on each one, so I added this function so I can strip away the
	first 7 chars (0001 - ) from the filenames so matching were a lot more exact. Also added the ability to remove chars from the end of the name.
	* We do a initial check for each search if there is a direct match for it. If there is, there is no need to search at all. Speeds it up a LOT with direct hits.
	* The number of sourcefiles found before splitting them into different arrays can now be set in the GUI. Previously it was hidden in the INI file.
#ce

Global $Version = "1.13"
Global $MediaDestination = "UNKNOWN"

Local $aArray_RomsListCleaned[0][3]
Local $aArray_SourceListCleaned[0][2]
Local $aArray_FinishedList[0][6]
Local $aArray_FinishedAutoList[0][6]
Local $aArray_NotFound[0][6]

TraySetToolTip("Tur-Matcher " & $Version)

HotKeySet("+{ESC}", "_Quit")

Global $SourcesToSplit = "10000"
Global $RomXML = ""
Global $RomXMLFile = ""
Global $RomXMLPath = ""
Global $RomFolder = ""
Global $HitLimit = "2"
Global $AutoCopyLimit = "0"
Global $SourceFolder = ""
Global $SelectedSourceFilesBrowse = ""
Global $DestinationFolder = ""
Global $ShowStatus = ""
Global $HandleDisks = "TRUE"
Global $Move = "FALSE"
Global $INIFile = @ScriptDir & "/Tur-Matcher.ini"

Global $ShowXML = "TRUE"
Global $SelectedXML = ""

If FileExists($INIFile) Then
	$SourcesToSplit = IniRead($INIFile, "General", "SourcesToSplit", "10000")
	$RomXML = IniRead($INIFile, "SavedSettings", "RomXML", "")
	$RomXMLFile = IniRead($INIFile, "SavedSettings", "RomXMLFile", "")
	$RomFolder = IniRead($INIFile, "SavedSettings", "RomFolder", "")
	$HitLimit = IniRead($INIFile, "SavedSettings", "HitLimit", "2")
	$AutoCopyLimit = IniRead($INIFile, "SavedSettings", "AutoCopyLimit", "0")
	$SourceFolder = IniRead($INIFile, "SavedSettings", "SourceFolder", "")
	$DestinationFolder = IniRead($INIFile, "SavedSettings", "DestinationFolder", "")
	$ShowStatus = IniRead($INIFile, "SavedSettings", "ShowStatus", "FALSE")
	$HandleDisks = IniRead($INIFile, "SavedSettings", "HandleDisks", "TRUE")
Else
	IniWrite($INIFile, "General", "SourcesToSplit", "10000")
EndIf

GoMainGUI()
GoMainProcessGUI()


Func GoMainGUI()
	Local $hGUI = GUICreate("Tur-Match " & $Version, 500, 575, -1, -1) ; Create the main GUI window.

	; -------------------------------------------------------------------------------------------------
	Global $AddXMLBackground = GUICtrlCreateLabel("", 5, 5, 490, 40, 0x12)
	GUICtrlSetState($AddXMLBackground, $GUI_DISABLE)

	Global $XMLSourceLabel = GUICtrlCreateLabel("XML Source:", 10, 16)
	Global $SelectedXMLGUI = GUICtrlCreateInput($RomXML & $RomXMLFile, 85, 13, 200, 23)
	Global $BrowseXMLButton = GUICtrlCreateButton("Browse XML", 290, 12, 90)

	Global $XMLOrFile = GUICtrlCreateButton("Switch to files", 385, 12, 100)

	Global $FilesSourceLabel = GUICtrlCreateLabel("Names From:", 10, 16)
	GUICtrlSetState($FilesSourceLabel, $GUI_HIDE)
	Global $SelectedFileGUI = GUICtrlCreateInput($RomFolder, 85, 13, 200, 23)
	GUICtrlSetState($SelectedFileGUI, $GUI_HIDE)
	Global $BrowseFileButton = GUICtrlCreateButton("Browse Files", 290, 12, 90)
	GUICtrlSetState($BrowseFileButton, $GUI_HIDE)

	; -------------------------------------------------------------------------------------------------
	Global $AddFileSourceBackground = GUICtrlCreateLabel("", 5, 48, 490, 80, 0x12)
	GUICtrlSetState($AddFileSourceBackground, $GUI_DISABLE)

	Global $SourceFilesDirLabel = GUICtrlCreateLabel("Source files:", 10, 59)
	Global $SourceFilesDir = GUICtrlCreateInput($SourceFolder, 85, 56, 295, 23)
	Global $BrowseSourceFilesButton = GUICtrlCreateButton("Browse", 385, 56, 100)

	Global $SourceFilesPreStrip = GUICtrlCreateCombo("", 115, 90, 40, 20)
	GUICtrlSetData($SourceFilesPreStrip, "0|1|2|3|4|5|6|7|8|9|10|11|12|13|14|15", 0)
	Global $SourceFilesPreStripLabel = GUICtrlCreateLabel("Pre Strip # of chars" & @CRLF & "from source name:", 10, 90)

	Global $SourceFilesPostStrip = GUICtrlCreateCombo("", 280, 90, 40, 20)
	GUICtrlSetData($SourceFilesPostStrip, "0|1|2|3|4|5|6|7|8|9|10|11|12|13|14|15", 0)
	Global $SourceFilesPostStripLabel = GUICtrlCreateLabel("Post Strip # of chars" & @CRLF & "from source name:", 170, 90)

	; -------------------------------------------------------------------------------------------------
	Global $AddFileDestinationBackground = GUICtrlCreateLabel("", 5, 130, 490, 40, 0x12)
	GUICtrlSetState($AddFileDestinationBackground, $GUI_DISABLE)

	Global $DestinationFilesDirLabel = GUICtrlCreateLabel("Destination:", 10, 141)
	Global $DestinationFilesDir = GUICtrlCreateInput($DestinationFolder, 85, 138, 295, 23)
	Global $BrowseDestinationFilesButton = GUICtrlCreateButton("Browse", 385, 138, 100)
	; -------------------------------------------------------------------------------------------------

	Global $AutoCopyLimitBackground = GUICtrlCreateLabel("", 5, 175, 490, 70, 0x12)
	GUICtrlSetState($AutoCopyLimitBackground, $GUI_DISABLE)
	Global $AutoCopyLimitGUILabel = GUICtrlCreateLabel("Number of " & Chr(34) & "misspellings" & Chr(34) & " to be automatically copied. Set to -1 to disable automatic copying." & @CRLF & "Anything with this number of " & Chr(34) & "misspellings" & Chr(34) & " will be considered a direct hit and copied automatically.", 10, 182)
	Global $AutoCopyGUI = GUICtrlCreateCombo("", 10, 216, 40, 20)
	GUICtrlSetData($AutoCopyGUI, "-1|0|1|2|3|4|5|6|7|8", $AutoCopyLimit)
	; -------------------------------------------------------------------------------------------------

	Global $LimitsBackground = GUICtrlCreateLabel("", 5, 250, 490, 70, 0x12)
	GUICtrlSetState($LimitsBackground, $GUI_DISABLE)

	Global $HitLimitGUILabel = GUICtrlCreateLabel("Number of " & Chr(34) & "misspellings" & Chr(34) & " to be counted as OK. Set to 0 to only match 100% matches." & @CRLF & "It will ask for manual selection at the end if the actual number is lower or equal to this.", 10, 256)
	Global $HitLimitGUI = GUICtrlCreateCombo("", 10, 286, 40, 20)
	GUICtrlSetData($HitLimitGUI, "0|1|2|3|4|5|6|7|8", $HitLimit)
	; -------------------------------------------------------------------------------------------------

	Global $MoveBackground = GUICtrlCreateLabel("", 5, 325, 490, 90, 0x12)
	GUICtrlSetState($MoveBackground, $GUI_DISABLE)
	Global $MoveSet = GUICtrlCreateCheckbox("Move Sourcefiles to Destination (Not recommended).", 10, 330, 270, 20, -1)
	Global $MoveWarning = GUICtrlCreateLabel("Important: Only use Move for ISO files or similar where there would be no more then one use for each" & @CRLF & "source media. If you select Move for other media (images), the sourcefile might be needed for more" & @CRLF & "then one match. An extra check will be executed to verify if it is possible so you will get the option to" & @CRLF & "change it to Copy later, should it fail the check", 10, 350)
	;GUICtrlSetState($MoveWarning, $GUI_DISABLE)

	; -------------------------------------------------------------------------------------------------

	Global $DontShowStatusBackGround = GUICtrlCreateLabel("", 5, 420, 490, 30, 0x12)
	GUICtrlSetState($DontShowStatusBackGround, $GUI_DISABLE)
	Global $DontShowStatusSet = GUICtrlCreateCheckbox("Do not show result windows. No questions until after the 100% matches are copied.", 10, 425, 470, 20, -1)
	If $ShowStatus = "FALSE" Then
		GUICtrlSetState($DontShowStatusSet, $GUI_CHECKED)
	EndIf

	; -------------------------------------------------------------------------------------------------

	Global $HandleDisksBackGround = GUICtrlCreateLabel("", 5, 455, 490, 30, 0x12)
	GUICtrlSetState($HandleDisksBackGround, $GUI_DISABLE)
	Global $HandleDisksSet = GUICtrlCreateCheckbox("Handle different disks? Check this if you have media that uses " & Chr(34) & "(Disk 1)" & Chr(34) & " etc. A bit slower...", 10, 460, 470, 20, -1)
	If $HandleDisks = "TRUE" Then
		GUICtrlSetState($HandleDisksSet, $GUI_CHECKED)
	EndIf

	; -------------------------------------------------------------------------------------------------
	Global $SourcesToSplitBackGround = GUICtrlCreateLabel("", 5, 490, 490, 50, 0x12)
	GUICtrlSetState($SourcesToSplitBackGround, $GUI_DISABLE)
	Global $SourcesToSplitGUI = GUICtrlCreateInput($SourcesToSplit, 10, 495, 50, 23)
	Global $SourcesToSplitLabel = GUICtrlCreateLabel("Number of source files found before splitting them based on first character?" & @CRLF & "This will speed it up but might miss hits that do not start with the same character." & @CRLF & "Example: ""Another World"" will only search in source files starting with ""A"".", 65, 491)

	; -------------------------------------------------------------------------------------------------
	Global $ResetButton = GUICtrlCreateButton("Reset to Default", 4, 545)
	Global $GoButton = GUICtrlCreateButton("Start", 280, 545, 150)
	Global $idQuit = GUICtrlCreateButton("Quit", 440, 545, 55)
	; -------------------------------------------------------------------------------------------------


	GUISetState()
	While 1
		Switch GUIGetMsg()
			Case $ResetButton
				GUICtrlSetData($SelectedXMLGUI, "")
				GUICtrlSetData($SelectedFileGUI, "")
				GUICtrlSetData($SourceFilesDir, "")
				GUICtrlSetData($DestinationFilesDir, "")
				GUICtrlSetData($AutoCopyGUI, "-1|0|1|2|3|4|5|6|7|8", "0")
				GUICtrlSetData($HitLimitGUI, "0|1|2|3|4|5|6|7|8", "2")
				GUICtrlSetState($MoveSet, $GUI_UNCHECKED)
				GUICtrlSetState($DontShowStatusSet, $GUI_UNCHECKED)

			Case $GoButton
				Local $OKToStart = "TRUE"

				If $ShowXML = "TRUE" Then
					Global $RomXML = GUICtrlRead($SelectedXMLGUI)
					Global $RomFolder = ""
					If $RomXML = "" Then
						MsgBox(16, "XML Source Error", "Please specify a XML file.")
						$OKToStart = "FALSE"
					Else
						Local $sDrive = "", $sDir = "", $sFilename = "", $sExtension = ""
						Local $aPathSplit = _PathSplit($RomXML, $sDrive, $sDir, $sFilename, $sExtension)
						Global $RomXMLPath = $aPathSplit[1] & $aPathSplit[2]
						Global $RomXMLFile = $aPathSplit[3] & $aPathSplit[4]

						If Not FileExists($RomXMLPath & $RomXMLFile) Then
							MsgBox(16, "XML File error", Chr(34) & $RomXMLPath & $RomXMLFile & Chr(34) & " does not exist")
							$OKToStart = "FALSE"
						EndIf
					EndIf
				Else
					Global $RomFolder = GUICtrlRead($SelectedFileGUI)
					Global $RomXML = ""

					If $RomFolder = "" Then
						MsgBox(16, "Names From Error", "Please specify a directory.")
						$OKToStart = "FALSE"
					Else
						If Not FileExists($RomFolder) Then
							MsgBox(16, "Names From Error", Chr(34) & $RomFolder & Chr(34) & " does not exist")
							$OKToStart = "FALSE"
						EndIf
						If $RomFolder = $SourceFolder Then
							MsgBox(16, "Error", "The " & Chr(34) & "Names From" & Chr(34) & " selection can not be the same as the " & Chr(34) & "Source files" & Chr(34))
							$OKToStart = "FALSE"
						EndIf
					EndIf
				EndIf

				If $OKToStart = "TRUE" Then
					Global $SourceFolder = GUICtrlRead($SourceFilesDir)
					If $SourceFolder = "" Then
						MsgBox(16, "Source Files Error", "Please specify a Source files path.")
						$OKToStart = "FALSE"
					Else
						If Not FileExists($SourceFolder) Then
							MsgBox(16, "Source folder error", Chr(34) & $SourceFolder & Chr(34) & " does not exist")
							$OKToStart = "FALSE"
						EndIf
					EndIf
					Global $SourceFilesPreStripNumber = GUICtrlRead($SourceFilesPreStrip)
					If Int(StringIsInt($SourceFilesPreStripNumber)) + Int(StringIsFloat($SourceFilesPreStripNumber)) <> "1" Then
						$OKToStart = "FALSE"
						MsgBox(16, "SourceFilesPreStrip error", "You must use a number.")
					EndIf

					Global $SourceFilesPostStripNumber = GUICtrlRead($SourceFilesPostStrip)
					If Int(StringIsInt($SourceFilesPostStripNumber)) + Int(StringIsFloat($SourceFilesPostStripNumber)) <> "1" Then
						$OKToStart = "FALSE"
						MsgBox(16, "SourceFilesPostStrip error", "You must use a number.")
					EndIf
				EndIf

				If $OKToStart = "TRUE" Then
					Global $DestinationFolder = GUICtrlRead($DestinationFilesDir)
					If $DestinationFolder = "" Then
						MsgBox(16, "Destination error", "Please specify a destinaion directory")
						$OKToStart = "FALSE"
					Else
						If Not FileExists($DestinationFolder) Then
							Local $CreateDestination = MsgBox(4 + 32, "Destination folder error", Chr(34) & $DestinationFolder & Chr(34) & " does not exist. Do you want to create it?")
							If $CreateDestination = "6" Then
								Local $DirCreateReturnCode = DirCreate($DestinationFolder)
								If Not FileExists($DestinationFolder) Then
									MsgBox(16, "Failed", "Failed to create " & $DestinationFolder & @CRLF & "Error: " & $DirCreateReturnCode)
									$OKToStart = "FALSE"
								EndIf
							Else
								$OKToStart = "FALSE"
							EndIf
						EndIf
					EndIf
				EndIf

				If $OKToStart = "TRUE" Then
					If $SourceFolder = $DestinationFolder Then
						MsgBox(16, "Error", "Source and Destination can not be the same dir...")
						$OKToStart = "FALSE"
					EndIf
				EndIf

				Global $AutoCopyLimit = GUICtrlRead($AutoCopyGUI)
				If Int(StringIsInt($AutoCopyLimit)) + Int(StringIsFloat($AutoCopyLimit)) <> "1" Then
					$OKToStart = "FALSE"
					MsgBox(16, "AutoCopyLimit error: " & $AutoCopyLimit, "You must put a number as the 100% match limit.")
				EndIf

				Global $HitLimit = GUICtrlRead($HitLimitGUI)
				If Int(StringIsInt($HitLimit)) + Int(StringIsFloat($HitLimit)) <> "1" Then
					$OKToStart = "FALSE"
					MsgBox(16, "HitLimit error: " & $HitLimit, "You must put a number as the HitLimit limit.")
				EndIf

				Global $SourcesToSplit = GUICtrlRead($SourcesToSplitGUI)
				If Int(StringIsInt($SourcesToSplit)) + Int(StringIsFloat($SourcesToSplit)) <> "1" Then
					$OKToStart = "FALSE"
					MsgBox(16, "SourcesToSplit error: " & $SourcesToSplit, "You must put a number as the number of sourcefiles before split.")
				EndIf

				If GUICtrlRead($MoveSet) = "1" Then
					Global $Move = "TRUE"
				Else
					Global $Move = "FALSE"
				EndIf

				If GUICtrlRead($DontShowStatusSet) = "1" Then
					Global $ShowArrays = "FALSE"
				Else
					Global $ShowArrays = "TRUE"
				EndIf

				If GUICtrlRead($HandleDisksSet) = "1" Then
					Global $HandleDisks = "TRUE"
				Else
					Global $HandleDisks = "FALSE"
				EndIf


				If $OKToStart = "TRUE" Then
					IniWrite($INIFile, "SavedSettings", "AutoCopyLimit", $AutoCopyLimit)
					IniWrite($INIFile, "SavedSettings", "HitLimit", $HitLimit)
					IniWrite($INIFile, "SavedSettings", "SourceFolder", $SourceFolder)
					IniWrite($INIFile, "SavedSettings", "DestinationFolder", $DestinationFolder)
					If $RomXMLPath <> "" Then
						IniWrite($INIFile, "SavedSettings", "RomXML", $RomXMLPath)
						IniWrite($INIFile, "SavedSettings", "RomXMLFile", $RomXMLFile)
					EndIf
					If $RomFolder <> "" Then
						IniWrite($INIFile, "SavedSettings", "RomFolder", $RomFolder)
					EndIf
					IniWrite($INIFile, "SavedSettings", "ShowStatus", $ShowArrays)
					IniWrite($INIFile, "SavedSettings", "HandleDisks", $HandleDisks)
					IniWrite($INIFile, "General", "SourcesToSplit", $SourcesToSplit)

					ExitLoop
				EndIf

			Case $BrowseDestinationFilesButton
				; Reread these 2 so we know where to go as default. It there is something in the destination, go there, otherwise go the the source files folder by default.
				Global $DestinationFolder = GUICtrlRead($DestinationFilesDir)
				Global $SourceFolder = GUICtrlRead($SourceFilesDir)
				If $DestinationFolder = "" And $SourceFolder <> "" Then
					$DestinationFolder = $SourceFolder
				EndIf
				Global $SelectedDestinationFilesBrowse = FileSelectFolder("Select folder to save renamed media to", $DestinationFolder)
				If $SelectedDestinationFilesBrowse <> "" Then
					GUICtrlSetData($DestinationFilesDir, $SelectedDestinationFilesBrowse)
				EndIf
			Case $BrowseSourceFilesButton
				Global $SelectedSourceFilesBrowse = FileSelectFolder("Select folder for source files to be renamed", $SourceFolder)
				If $SelectedSourceFilesBrowse <> "" Then
					GUICtrlSetData($SourceFilesDir, $SelectedSourceFilesBrowse)
				EndIf
			Case $BrowseXMLButton
				Global $SelectedXMLBrowse = FileOpenDialog("Select XML to get the correct filenames from", $RomXML, "XML File (*.XML)", 1)
				If $SelectedXMLBrowse <> "" Then
					GUICtrlSetData($SelectedXMLGUI, $SelectedXMLBrowse)
				EndIf
			Case $BrowseFileButton
				Global $SelectedFilesBrowse = FileSelectFolder("Select folder to get corrent filenames from", $RomFolder)
				If $SelectedFilesBrowse <> "" Then
					GUICtrlSetData($SelectedFileGUI, $SelectedFilesBrowse)
				EndIf
			Case $XMLOrFile
				If $ShowXML = "TRUE" Then
					GUICtrlSetState($FilesSourceLabel, $GUI_SHOW)
					GUICtrlSetState($SelectedFileGUI, $GUI_SHOW)
					GUICtrlSetState($BrowseFileButton, $GUI_SHOW)
					GUICtrlSetState($XMLSourceLabel, $GUI_HIDE)
					GUICtrlSetState($SelectedXMLGUI, $GUI_HIDE)
					GUICtrlSetState($BrowseXMLButton, $GUI_HIDE)
					GUICtrlDelete($XMLOrFile)
					Global $XMLOrFile = GUICtrlCreateButton("Switch to XML", 385, 12, 100)
					Global $ShowXML = "FALSE"
				Else
					GUICtrlSetState($FilesSourceLabel, $GUI_HIDE)
					GUICtrlSetState($SelectedFileGUI, $GUI_HIDE)
					GUICtrlSetState($BrowseFileButton, $GUI_HIDE)
					GUICtrlSetState($XMLSourceLabel, $GUI_SHOW)
					GUICtrlSetState($SelectedXMLGUI, $GUI_SHOW)
					GUICtrlSetState($BrowseXMLButton, $GUI_SHOW)
					GUICtrlDelete($XMLOrFile)
					Global $XMLOrFile = GUICtrlCreateButton("Switch to files", 385, 12, 100)
					Global $ShowXML = "TRUE"
				EndIf
			Case $GUI_EVENT_CLOSE
				Exit
			Case $idQuit
				Exit
		EndSwitch
		Sleep(20)
	WEnd
	GUIDelete($hGUI)
EndFunc   ;==>GoMainGUI

; Function to add information to the local log window and scroll to the bottom of it automatically.
Func AddToLog($Msg, $LogWindow)
	GUICtrlCreateListViewItem(@HOUR & ":" & @MIN & ":" & @SEC & " " & $Msg, $LogWindow)
	_GUICtrlListView_Scroll($LogWindow, 0, 50000)
EndFunc   ;==>AddToLog

Func GoMainProcessGUI()

	Local $hGUI = GUICreate("Tur-Match " & $Version & " - Processing! Press Shift-Esc to abort at any time.", 500, 445, -1, -1, $WS_SIZEBOX + $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX) ; Create the main GUI window.

	Global $LogWindowMain = GUICtrlCreateListView("Main Log", 10, 10, 480, 200, 0x8000)
	GUICtrlSetResizing($LogWindowMain, $GUI_DOCKLEFT + $GUI_DOCKTOP)
	_GUICtrlListView_SetColumnWidth($LogWindowMain, 0, 1000)
	Global $LogWindowDebug = GUICtrlCreateListView("Debug Log", 10, 220, 480, 180)
	GUICtrlSetResizing($LogWindowDebug, $GUI_DOCKLEFT + $GUI_DOCKBOTTOM)
	_GUICtrlListView_SetColumnWidth($LogWindowDebug, 0, 1000)
	_GUICtrlListView_SetItemCount($LogWindowDebug, 1000)

	GUISetState()

	If Not FileExists(@ScriptDir & "\Logs") Then
		AddToLog("Creating Logs directory.", $LogWindowMain)
		DirCreate(@ScriptDir & "\Logs")
	EndIf

	If $RomXML = "" Then ; User selected to use Roms as RomList, not the XML
		$RomsList = _FileListToArray($RomFolder & "\")
		AddToLog("Indexing " & $RomsList[0] & " files for source names...", $LogWindowMain)
		If @error = 1 Then
			MsgBox(0, "", "No Files Found in " & $RomFolder & "\")
			Exit
		EndIf
		$Matched = "0"
		For $i = 1 To $RomsList[0]
			$RomName = $RomsList[$i]
			AddToLog("Indexing source name " & $i & "/" & $RomsList[0] & ": " & $RomName, $LogWindowDebug)

			$RomNameNoExt = RemoveExtRegExp($RomName)
			$RomNameClean = _CleanName($RomNameNoExt)

			_ArrayAdd($aArray_RomsListCleaned, $RomName & "|" & $RomNameClean & "|" & $RomNameNoExt)
		Next

	Else ; User selected to use a XML file as RomList.
		Local $hFileOpen = FileOpen($RomXML, 0)
		If $hFileOpen = -1 Then
			MsgBox(16, "", "An error occurred when reading the XML file.")
			Exit
		EndIf

		$Rows = _FileCountLines($RomXML)
		Local $GamesFound = 0
		AddToLog("Indexing " & $Rows & " rows in XML. Please wait.", $LogWindowMain)

		For $i = 1 To $Rows
			$line = FileReadLine($hFileOpen, $i)
			If StringInStr($line, "<game name=") Then
				$GamesFound = $GamesFound + 1
				Local $GameNameArray = StringSplit($line, '"')
				$RomName = $GameNameArray[2]
				If $RomName <> "" Then

					$RomName = StringReplace($RomName, '&amp;', '&') ; Cleanup of XML codes.
					$RomName = StringReplace($RomName, '&apos;', "'") ; Cleanup of XML codes.

					$RomNameClean = _CleanName($RomName)

					_ArrayAdd($aArray_RomsListCleaned, $RomName & "|" & $RomNameClean & "|" & $RomName)
					ConsoleWrite(StringFormat($RomName & "\n"))
					AddToLog("Row " & $i & "/" & $Rows & " - Games found: " & $GamesFound & " (" & $RomName & ")", $LogWindowDebug)
				EndIf
			EndIf
		Next
		FileClose($hFileOpen)

	EndIf

	AddToLog("Logging source names to " & @ScriptDir & "\Logs\SourceNames.txt", $LogWindowMain)
	_ArraySort($aArray_RomsListCleaned)
	$FileName = FileOpen(@ScriptDir & "\Logs\SourceNames.txt", 2)
	FileWrite($FileName, "Source Name" & @TAB & "Source Name Cleaned" & @TAB & "Source Name No Extensions" & @CRLF)
	_FileWriteFromArray($FileName, $aArray_RomsListCleaned, 0, Default, @TAB)
	FileClose($FileName)

	If $Move = "TRUE" Then
		AddToLog("Move is checked. Checking that it will work.", $LogWindowMain)
		$RomsToCheck = UBound($aArray_RomsListCleaned) ; Check how many roms we have in the array.
		Local $LastRomNameClean = ""
		For $i = 0 To $RomsToCheck - 1 ; Here we go. Loop through every rom in the list. (-1 is because we start at 0 but $RomsToCheck start at 1.)
			$RomNameClean = $aArray_RomsListCleaned[$i][1]
			If $RomNameClean = $LastRomNameClean Then
				AddToLog("... it will not.", $LogWindowMain)
				$ContinueAnyway = MsgBox(16 + 4, "Error!", "You have selected to MOVE the source media, but the rom " & Chr(34) & $LastRomNameClean & Chr(34) & " will need the same source media twice which will not work if you move it." & @CRLF & @CRLF & "Do you want to change to COPY mode instead? Selecting No will abort.")
				If $ContinueAnyway = 6 Then
					AddToLog("Changing to COPY mode instead as requested.", $LogWindowMain)
					Global $Move = "FALSE"
				Else
					Exit
				EndIf
				ExitLoop
			EndIf
			$LastRomNameClean = $RomNameClean
		Next
	EndIf

	If $ShowArrays = "TRUE" Then
		AddToLog("Displaying source NAMES.", $LogWindowMain)
		_ArrayDisplay($aArray_RomsListCleaned, $i & " Source names found. Close this window on the upper X to continue.", "", 16, -1, "Source Name|Source Name Cleaned|Source Name No Extensions", Default, 0xDDFFDD)
	Else
		AddToLog("NOT Displaying source NAMES.", $LogWindowMain)
	EndIf

	AddToLog("Indexing source files", $LogWindowMain)

	$SourceList = _FileListToArray($SourceFolder & "\")

	$LastSourceNameClean = ""
	For $i = 1 To $SourceList[0]

		$SourceName = $SourceList[$i]

		AddToLog("Row " & $i & "/" & $SourceList[0] & " - source found: " & $SourceName, $LogWindowDebug)
		$SourceNameNoExt = RemoveExtRegExp($SourceName)

		If $SourceFilesPreStripNumber <> 0 Then
			If StringLen($SourceNameNoExt) > $SourceFilesPreStripNumber Then
				$SourceNameNoExt = StringTrimLeft($SourceNameNoExt, $SourceFilesPreStripNumber)
			EndIf
		EndIf

		$SourceNameClean = _CleanName($SourceNameNoExt)

		If $SourceFilesPostStripNumber <> 0 Then
			If StringLen($SourceNameClean) > $SourceFilesPostStripNumber Then
				$SourceNameClean = StringTrimRight($SourceNameClean, $SourceFilesPostStripNumber)
			EndIf
		EndIf

		If $LastSourceNameClean <> $SourceNameClean Then
			_ArrayAdd($aArray_SourceListCleaned, $SourceName & "|" & $SourceNameClean)
		EndIf
		$LastSourceNameClean = $SourceNameClean
	Next

	_ArraySort($aArray_SourceListCleaned)

	AddToLog("Logging source files to " & @ScriptDir & "\Logs\SourceFiles.txt", $LogWindowMain)
	$FileName = FileOpen(@ScriptDir & "\Logs\SourceFiles.txt", 2)
	FileWrite($FileName, "Source Name" & @TAB & "Source Name Cleaned" & @CRLF)
	_FileWriteFromArray($FileName, $aArray_SourceListCleaned, 0, Default, @TAB)
	FileClose($FileName)

	If $ShowArrays = "TRUE" Then
		AddToLog("Displaying source FILES.", $LogWindowMain)
		_ArrayDisplay($aArray_SourceListCleaned, $i & " Source files Found. Close this window on the upper X to continue.", "", 16, -1, "Source Name|Source Name Cleaned", Default, 0xDDFFDD)
	Else
		AddToLog("NOT Displaying source files.", $LogWindowMain)
	EndIf

	$SourcesToCheck = UBound($aArray_SourceListCleaned) - 1 ; How many sources do we have in that array?
	Global $SplitArrays = "FALSE"
	If $SourcesToCheck > $SourcesToSplit Then
		$SplitArrays = "TRUE"
		If $ShowArrays = "TRUE" Then
			MsgBox(0, "Lots of sourcefiles!", "We have " & $SourcesToCheck & " files as source files. This is a lot and more then the " & $SourcesToSplit & " we have set as a limit." & @CRLF & "We'll split up the sourcefiles into different arrays for each letter to speed up the search." & @CRLF & @CRLF & "This will speed it up alot with that number of source files, but it might lower the chance of a match since we first check the first char. Raise the ""Number of source files found before splitting"" value to not split it and take the slowdown hit.", 120)
		EndIf
		AddToLog("Splitting up sourcefiles into alphabetical arrays.", $LogWindowMain)
		Local $aArray_SourceListCleaned0[0][2]
		Local $aArray_SourceListCleanedA[0][2]
		Local $aArray_SourceListCleanedB[0][2]
		Local $aArray_SourceListCleanedC[0][2]
		Local $aArray_SourceListCleanedD[0][2]
		Local $aArray_SourceListCleanedE[0][2]
		Local $aArray_SourceListCleanedF[0][2]
		Local $aArray_SourceListCleanedG[0][2]
		Local $aArray_SourceListCleanedH[0][2]
		Local $aArray_SourceListCleanedI[0][2]
		Local $aArray_SourceListCleanedJ[0][2]
		Local $aArray_SourceListCleanedK[0][2]
		Local $aArray_SourceListCleanedL[0][2]
		Local $aArray_SourceListCleanedM[0][2]
		Local $aArray_SourceListCleanedN[0][2]
		Local $aArray_SourceListCleanedO[0][2]
		Local $aArray_SourceListCleanedP[0][2]
		Local $aArray_SourceListCleanedQ[0][2]
		Local $aArray_SourceListCleanedR[0][2]
		Local $aArray_SourceListCleanedS[0][2]
		Local $aArray_SourceListCleanedT[0][2]
		Local $aArray_SourceListCleanedU[0][2]
		Local $aArray_SourceListCleanedV[0][2]
		Local $aArray_SourceListCleanedW[0][2]
		Local $aArray_SourceListCleanedX[0][2]
		Local $aArray_SourceListCleanedY[0][2]
		Local $aArray_SourceListCleanedZ[0][2]

		For $k = 0 To $SourcesToCheck ; Go through each source in the source array!
			$SourceName = $aArray_SourceListCleaned[$k][0] ; Get the sourcename
			$SourceNameClean = $aArray_SourceListCleaned[$k][1] ; Get the cleaned SourceName
			Local $Letter = StringUpper(StringLeft($SourceNameClean, 1))
			Switch $Letter
				Case "A"
					_ArrayAdd($aArray_SourceListCleanedA, $SourceName & "|" & $SourceNameClean)
				Case "B"
					_ArrayAdd($aArray_SourceListCleanedB, $SourceName & "|" & $SourceNameClean)
				Case "C"
					_ArrayAdd($aArray_SourceListCleanedC, $SourceName & "|" & $SourceNameClean)
				Case "D"
					_ArrayAdd($aArray_SourceListCleanedD, $SourceName & "|" & $SourceNameClean)
				Case "E"
					_ArrayAdd($aArray_SourceListCleanedE, $SourceName & "|" & $SourceNameClean)
				Case "F"
					_ArrayAdd($aArray_SourceListCleanedF, $SourceName & "|" & $SourceNameClean)
				Case "G"
					_ArrayAdd($aArray_SourceListCleanedG, $SourceName & "|" & $SourceNameClean)
				Case "H"
					_ArrayAdd($aArray_SourceListCleanedH, $SourceName & "|" & $SourceNameClean)
				Case "I"
					_ArrayAdd($aArray_SourceListCleanedI, $SourceName & "|" & $SourceNameClean)
				Case "J"
					_ArrayAdd($aArray_SourceListCleanedJ, $SourceName & "|" & $SourceNameClean)
				Case "K"
					_ArrayAdd($aArray_SourceListCleanedK, $SourceName & "|" & $SourceNameClean)
				Case "L"
					_ArrayAdd($aArray_SourceListCleanedL, $SourceName & "|" & $SourceNameClean)
				Case "M"
					_ArrayAdd($aArray_SourceListCleanedM, $SourceName & "|" & $SourceNameClean)
				Case "N"
					_ArrayAdd($aArray_SourceListCleanedN, $SourceName & "|" & $SourceNameClean)
				Case "O"
					_ArrayAdd($aArray_SourceListCleanedO, $SourceName & "|" & $SourceNameClean)
				Case "P"
					_ArrayAdd($aArray_SourceListCleanedP, $SourceName & "|" & $SourceNameClean)
				Case "Q"
					_ArrayAdd($aArray_SourceListCleanedQ, $SourceName & "|" & $SourceNameClean)
				Case "R"
					_ArrayAdd($aArray_SourceListCleanedR, $SourceName & "|" & $SourceNameClean)
				Case "S"
					_ArrayAdd($aArray_SourceListCleanedS, $SourceName & "|" & $SourceNameClean)
				Case "T"
					_ArrayAdd($aArray_SourceListCleanedT, $SourceName & "|" & $SourceNameClean)
				Case "U"
					_ArrayAdd($aArray_SourceListCleanedU, $SourceName & "|" & $SourceNameClean)
				Case "V"
					_ArrayAdd($aArray_SourceListCleanedV, $SourceName & "|" & $SourceNameClean)
				Case "W"
					_ArrayAdd($aArray_SourceListCleanedW, $SourceName & "|" & $SourceNameClean)
				Case "X"
					_ArrayAdd($aArray_SourceListCleanedX, $SourceName & "|" & $SourceNameClean)
				Case "Y"
					_ArrayAdd($aArray_SourceListCleanedY, $SourceName & "|" & $SourceNameClean)
				Case "Z"
					_ArrayAdd($aArray_SourceListCleanedZ, $SourceName & "|" & $SourceNameClean)
				Case Else
					_ArrayAdd($aArray_SourceListCleaned0, $SourceName & "|" & $SourceNameClean)
			EndSwitch
		Next
	EndIf

	Global $Letter
	Global $LastLetter
	Global $LastRomNameClean
	Global $LastbestMatch
	Global $LastBestMatchNameCleaned
	Global $LastBestMatchName
	Global $LastbestMatchIdx
	Global $bestMatchIdx
	Global $bestMatch
	Global $BestMatchNameExt


	$Runs = 0
	$RomsToCheck = UBound($aArray_RomsListCleaned) ; Check how many roms we have in the array.

	AddToLog("Starting matching...", $LogWindowMain)

	For $i = 0 To $RomsToCheck - 1 ; Here we go. Loop through every rom in the list. (-1 is because we start at 0 but $RomsToCheck start at 1.)
		$Skip = "FALSE" ; Set this to false. We will do some checks and then we can set it to TRUE to have it skipped later.
		$RomNameNoExtension = $aArray_RomsListCleaned[$i][2] ; Get the RomName with no extension.

		AddToLog("Matching " & $RomNameNoExtension & " (" & $i & "/" & $RomsToCheck & ")", $LogWindowDebug)
		If FileExists($DestinationFolder & "\" & $RomNameNoExtension & ".*") Then ; If this destination file already exists (actually checks .* so extension does not matter).
			AddToLog("Skipping " & $RomNameNoExtension & " as it already exists in " & $DestinationFolder, $LogWindowDebug)
			ConsoleWrite(StringFormat("Skipping " & Chr(34) & $RomNameNoExtension & Chr(34) & " as it already exists in " & $DestinationFolder & "\n"))
			$Skip = "TRUE" ; Destination file already exists so we can skip this item.
		EndIf

		If $Skip = "FALSE" Then ; Should we continue with this item? No use getting these values otherwise.
			$RomName = $aArray_RomsListCleaned[$i][0]
			$RomNameClean = $aArray_RomsListCleaned[$i][1] ; Get the romname
			ConsoleWrite(StringFormat($Runs & ": Checking " & $RomNameClean & " -> "))
		EndIf

		; If this is the same romname as the last one, use the same source. No need to search again.
		If $Skip = "FALSE" Then ; Should we continue with this item?
			If $RomNameClean = $LastRomNameClean Then
				$Skip = "TRUE"
				ConsoleWrite(StringFormat("SAME match (Array: " & $Letter & "): " & $LastBestMatchName & " (" & $LastbestMatchIdx & ") with " & $LastbestMatch & " spelling errors\n"))
				AddToLog($LastBestMatchNameCleaned & " (" & $LastbestMatch & ") Sources (" & $Letter & "):" & $SourcesToCheck, $LogWindowDebug)
				If $HitLimit + 1 > $bestMatch Then
					If $AutoCopyLimit >= $LastbestMatch Then
						_ArrayAdd($aArray_FinishedAutoList, $RomNameClean & "|" & $LastBestMatchNameCleaned & "|" & $RomName & "|" & $LastBestMatchName & "|" & $LastbestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt) ; Autocopy stuff.
					Else
						_ArrayAdd($aArray_FinishedList, $RomNameClean & "|" & $LastBestMatchNameCleaned & "|" & $RomName & "|" & $LastBestMatchName & "|" & $LastbestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt) ; Manual stuff we'll go through later.
					EndIf
				Else
					_ArrayAdd($aArray_NotFound, $RomNameClean & "|" & $LastBestMatchNameCleaned & "|" & $RomName & "|" & $LastBestMatchName & "|" & $LastbestMatch) ; Stuff that did not make the cut at all.
				EndIf
			EndIf
		EndIf

		If $Skip = "FALSE" Then ; Should we continue with this item?
			$Runs = $Runs + 1
			; This is debug if we want to only run a portion of the roms.
			;	  If $Runs > "50" Then
			;		ExitLoop
			;	  EndIf

			; Reset these values for each item we go through.
			$ExactHit = "FALSE"
			$bestMatch = ""
			$bestMatchIdx = ""

			Local $bestMatch = StringLen($RomNameClean) ; Get the lenght of the name we're going to test first. We'll compare the results to this number.

			If $SplitArrays = "TRUE" Then
				Local $Letter = StringUpper(StringLeft($RomNameClean, 1)); Get the first letter of the rom.

				; Always 0 if its 0-9 as they are all in the same array.
				If StringIsDigit($Letter) Then
					$Letter = "0"
				EndIf

				If $LastLetter <> $Letter Then
					AddToLog("Switching array to the letter " & $Letter & " (Starting with " & $RomNameClean & ")", $LogWindowMain)
					Switch $Letter
						Case "A"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedA
						Case "B"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedB
						Case "C"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedC
						Case "D"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedD
						Case "E"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedE
						Case "F"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedF
						Case "G"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedG
						Case "H"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedH
						Case "I"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedI
						Case "J"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedJ
						Case "K"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedK
						Case "L"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedL
						Case "M"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedM
						Case "N"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedN
						Case "O"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedO
						Case "P"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedP
						Case "Q"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedQ
						Case "R"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedR
						Case "S"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedS
						Case "T"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedT
						Case "U"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedU
						Case "V"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedV
						Case "W"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedW
						Case "X"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedX
						Case "Y"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedY
						Case "Z"
							$aArray_SourceListCleaned = $aArray_SourceListCleanedZ
						Case Else
							$aArray_SourceListCleaned = $aArray_SourceListCleaned0
					EndSwitch
				EndIf
			EndIf

			; Check for a direct hit here. If the name is found exactly as is, there is no reason to search any further.
			Local $DirectMatchNumber = _ArraySearch($aArray_SourceListCleaned, $RomNameClean,-1,-1,1,2,2)
			If $DirectMatchNumber <> -1 Then
				$bestMatch = 0
				$bestMatchIdx = $DirectMatchNumber
				$ExactHit = "TRUE"
				;MsgBox(0,$RomNameClean , $aArray_SourceListCleaned[$bestMatchIdx][0])
			Else ; A direct hit was not found so do the typos checking.
				$SourcesToCheck = UBound($aArray_SourceListCleaned) - 1 ; How many sources do we have in that array?
				For $k = 0 To $SourcesToCheck ; Go through each source in the source array!
					$SourceNameClean = $aArray_SourceListCleaned[$k][1] ; Get the cleaned SourceName
					$typos = _Typos($SourceNameClean, $RomNameClean) ; Run a comparison on SourceNameClean and RomNameClean. It will return the differences between them.
					If $typos < $bestMatch Then ; If this difference is lower then the previous one, its a better match and we need to update $bestMatch and $bestMatchIdx with the better hit.

						$bestMatch = $typos
						$bestMatchIdx = $k

						; In theory, it should never get a direct hit here as we check for direct hits above, however, the wording may be different
						; IE: "Mass Effect" is not a direct hit to "Effect Mass" in the first check, but with a typos check, it is, so leaving this here.
						If $typos = 0 Then ; If $typos is 0, it means it an exact hit.
							$ExactHit = "TRUE" ; We need this for later.
							ExitLoop ; Exit the loop through the sources. No need to if we found a perfect match already. Speeds things up.
						EndIf
					EndIf
				Next
			EndIf

			; Nothing found...
			If $bestMatchIdx == "" And $ExactHit = "FALSE" Then ; This mofo fails if $bestMatchIdx is 0, so make sure to use == to do a strict binary-wise compare.
				$bestMatchIdx = "NA"
				$BestMatchName = "Nothing"
				$bestMatch = "Nothing"
				ConsoleWrite(StringFormat("No hit for " & $RomName & "\n"))
				AddToLog("No hit for " & $RomName, $LogWindowDebug)
				_ArrayAdd($aArray_NotFound, $RomNameClean & "|NA|" & $RomName & "|NA|NA") ; Stuff that did not make the cut at all.
			Else
				$BestMatchName = $aArray_SourceListCleaned[$bestMatchIdx][0] ; Get the best matched fullname
				$BestMatchNameExt = _FileGetExt($BestMatchName) ; Get the extension from the best matched fullname. That will be the destination extension.
				$BestMatchNameCleaned = $aArray_SourceListCleaned[$bestMatchIdx][1] ; Also get the best matched cleaned name.
				If $SplitArrays = "FALSE" Then
					ConsoleWrite(StringFormat("Best match : " & $BestMatchName & " (" & $bestMatchIdx & ") with " & $bestMatch & " spelling errors\n"))
					AddToLog("Best match: " & $BestMatchName & " (" & $bestMatchIdx & ") with " & $bestMatch & " spelling errors", $LogWindowDebug)
				Else
					ConsoleWrite(StringFormat("Best match (Array: " & $Letter & "): " & $BestMatchName & " (" & $bestMatchIdx & ") with " & $bestMatch & " spelling errors\n"))
					AddToLog("Best match (Array: " & $Letter & "): " & $BestMatchName & " (" & $bestMatchIdx & ") with " & $bestMatch & " spelling errors", $LogWindowDebug)
				EndIf
				If $HitLimit + 1 > $bestMatch Then
					If $AutoCopyLimit >= $bestMatch Then
						_ArrayAdd($aArray_FinishedAutoList, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt) ; Autocopy stuff.
					Else
						_ArrayAdd($aArray_FinishedList, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt) ; Manual stuff we'll go through later.
					EndIf
				Else
					_ArrayAdd($aArray_NotFound, $RomNameClean & "|" & $BestMatchNameCleaned & "|" & $RomName & "|" & $BestMatchName & "|" & $bestMatch & "|" & $RomNameNoExtension & $BestMatchNameExt) ; Stuff that did not make the cut at all.
				EndIf
				$LastRomNameClean = $RomNameClean
				$LastbestMatchIdx = $bestMatchIdx
				$LastbestMatch = $bestMatch
				$LastBestMatchNameCleaned = $BestMatchNameCleaned
				$LastBestMatchName = $BestMatchName
			EndIf

			If $ExactHit = "TRUE" Then ; If this was a direct hit (0), we can remove this hit from the Sourcenames array to speed up search.
				If $SourcesToCheck > "50" Then ; No point in removing anything from the sources array if its less then 50 items in it.
					If $i + 1 < $RomsToCheck Then ; Make sure there are one more item in coming up in the rom array.
						$RomNameNextClean = $aArray_RomsListCleaned[$i + 1][1] ; Grab the next rom thats coming up.
						If $RomNameClean <> $RomNameNextClean Then ; If the current rom is NOT the same as the next rom, we can remove this source from the source array to speed up searches.
							_ArrayDelete($aArray_SourceListCleaned, $bestMatchIdx); Delete this item from array.
						EndIf
					EndIf
				EndIf
			EndIf

		EndIf

		If $SplitArrays = "TRUE" Then
			$LastLetter = $Letter
		EndIf

	Next

	AddToLog("Logging Auto Copy files to " & @ScriptDir & "\Logs\AutoCopy.txt", $LogWindowMain)
	$FileName = FileOpen(@ScriptDir & "\Logs\AutoCopy.txt", 2)
	FileWrite($FileName, "Source Name Clean" & @TAB & "Source File Clean" & @TAB & "Source Full Name" & @TAB & "Source File Full Name" & @TAB & "Misspellings" & @TAB & "New Name" & @CRLF)
	_FileWriteFromArray($FileName, $aArray_FinishedAutoList, 0, Default, @TAB)
	FileClose($FileName)

	If UBound($aArray_FinishedAutoList) = "0" Then
		MsgBox(48, "No perfect matches", "We found no (new) perfect matches to be copied this time.", 20)
	Else
		If $ShowArrays = "TRUE" Then
			AddToLog("Displaying hits for automatic processing.", $LogWindowMain)
			_ArrayDisplay($aArray_FinishedAutoList, "Here are the items that will now be automatically copied. Press X to continue.", "", 16, -1, "Source Name Clean|Source File Clean|Source Full Name|Source File Full Name|Misspellings|New Name", Default, 0xDDFFDD)
		Else
			AddToLog("NOT displaying hits for automatic processing.", $LogWindowMain)
		EndIf
		AddToLog("Starting to copy files within the auto copy limit.", $LogWindowMain)
	EndIf

	For $i = 0 To UBound($aArray_FinishedAutoList) - 1

		$RomNameClean = $aArray_FinishedAutoList[$i][0]
		$BestMatchNameCleaned = $aArray_FinishedAutoList[$i][1]
		$RomName = $aArray_FinishedAutoList[$i][2]
		$BestMatchName = $aArray_FinishedAutoList[$i][3]
		$bestMatch = $aArray_FinishedAutoList[$i][4]
		$NewName = $aArray_FinishedAutoList[$i][5]

		If Not FileExists($DestinationFolder) Then
			MsgBox(16, "Failure", "Could not find destinationfolder" & @CRLF & $DestinationFolder & @CRLF & @CRLF & "Aborting.")
			Exit
		Else
			$DirOrFile = FileGetAttrib($SourceFolder & "\" & $BestMatchName)
			If StringInStr($DirOrFile, "D") Then
				If $Move = "TRUE" Then
					ConsoleWrite(StringFormat("Dir Automove: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
					If FileExists($SourceFolder & "\" & $BestMatchName) Then
						AddToLog("Auto Move DIR: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
						DirMove($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
					Else
						AddToLog($SourceFolder & "\" & $BestMatchName & " Dir no longer exists because it was moved previously. skipping.", $LogWindowDebug)
					EndIf
				Else
					AddToLog("Auto Copy DIR: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
					ConsoleWrite(StringFormat("Dir Autocopy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
					DirCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
				EndIf
			Else
				If $Move = "TRUE" Then
					ConsoleWrite(StringFormat("File Automove: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
					If FileExists($SourceFolder & "\" & $BestMatchName) Then
						AddToLog("Auto Move File: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
						FileMove($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
					Else
						AddToLog($SourceFolder & "\" & $BestMatchName & " File no longer exists because it was moved previously. skipping.", $LogWindowDebug)
					EndIf
				Else
					AddToLog("Auto Copy File: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
					ConsoleWrite(StringFormat("File Autocopy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
					FileCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
				EndIf
			EndIf
		EndIf
	Next

	AddToLog("Logging Manual Copy files to " & @ScriptDir & "\Logs\ManualCopy.txt", $LogWindowMain)
	$FileName = FileOpen(@ScriptDir & "\Logs\ManualCopy.txt", 2)
	FileWrite($FileName, "Source Name Clean" & @TAB & "Source File Clean" & @TAB & "Source Full Name" & @TAB & "Source File Full Name" & @TAB & "Misspellings" & @TAB & "New Name" & @CRLF)
	_FileWriteFromArray($FileName, $aArray_FinishedList, 0, Default, @TAB)
	FileClose($FileName)

	AddToLog("Displaying hits for manual processing.", $LogWindowMain)

	If UBound($aArray_FinishedList) = "0" Then
		MsgBox(64, "No partial matches found", "No (new) partial matches found this time.")
	Else
		;_ArrayDisplay($aArray_FinishedList, "Here are the items that we will go over now. Press X to continue.", "", 16, -1, "Source Name Clean|Source File Clean|Source Full Name|Source File Full Name|Misspellings|New Name", Default, 0xDDFFDD)
		_RunManualCopy($aArray_FinishedList)
	EndIf


	AddToLog("Logging No Match files to " & @ScriptDir & "\Logs\NoMatch.txt", $LogWindowMain)
	$FileName = FileOpen(@ScriptDir & "\Logs\NoMatch.txt", 2)
	FileWrite($FileName, "Source Name Clean" & @TAB & "Source File Clean" & @TAB & "Source Full Name" & @TAB & "Source File Full Name" & @TAB & "Misspellings" & @CRLF)
	_FileWriteFromArray($FileName, $aArray_NotFound, 0, Default, @TAB)
	FileClose($FileName)

	AddToLog("Displaying hits for things that did not match.", $LogWindowMain)

	If UBound($aArray_NotFound) = "0" Then
		MsgBox(64, "No unmatched media", "We found no (new) matches that did not fit anything. Goodie.")
	Else
		;_ArrayDisplay($aArray_NotFound, "Here are the best matches for unmatched media. Press X to quit the program.", "", 16, -1, "Source Name Clean|Best File Clean|source Full Name|Best File Full Name|Misspellings|New Name", Default, 0xDDFFDD)
		_RunManualCopy($aArray_NotFound)
	EndIf

	MsgBox(0, "Done!", "All done! Press OK to exit.")
	Exit

EndFunc   ;==>GoMainProcessGUI

Func _RunManualCopy($ArrayToWorkOn)

	Local $hGUI = GUICreate("Showing partial matches. Check all that you think are a match and press Start. Skip to move on. Quit to abort/exit.", 800, 435, -1, -1, $WS_SIZEBOX + $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX) ; Create the main GUI window.

	Local $MatchList = GUICtrlCreateListView("Source Name|Matched Name|Errors|Actual Source Name|Actual Source File", 10, 10, 780, 350, -1, BitOR($WS_EX_CLIENTEDGE, $LVS_EX_CHECKBOXES))
	GUICtrlSetResizing($MatchList, $GUI_DOCKLEFT + $GUI_DOCKTOP)
	GUICtrlSendMsg($MatchList, $LVM_SETCOLUMNWIDTH, 0, 185)
	Global $PartialItemList = ""
	Global $PartialItemList[UBound($ArrayToWorkOn)]

	For $i = 0 To UBound($ArrayToWorkOn) - 1
		$RomNameClean = $ArrayToWorkOn[$i][0]
		$LastBestMatchNameCleaned = $ArrayToWorkOn[$i][1]
		$RomName = $ArrayToWorkOn[$i][2]
		$LastBestMatchName = $ArrayToWorkOn[$i][3]
		$LastbestMatch = $ArrayToWorkOn[$i][4]
		If $LastbestMatch <> "NA" Then
			$PartialItemList[$i] = GUICtrlCreateListViewItem($RomNameClean & "|" & $LastBestMatchNameCleaned & "|" & $LastbestMatch & "|" & $RomName & "|" & $LastBestMatchName, $MatchList)
		EndIf
	Next

	Global $SavePartialButton = GUICtrlCreateButton("Start Copy/Move Process", 10, 370, 150)
	GUICtrlSetResizing($SavePartialButton, $GUI_DOCKLEFT + $GUI_DOCKSIZE)
	Global $SkipPartialButton = GUICtrlCreateButton("Skip", 170, 370, 50)
	GUICtrlSetResizing($SkipPartialButton, $GUI_DOCKLEFT + $GUI_DOCKSIZE)
	Global $idQuit = GUICtrlCreateButton("Quit", 230, 370, 50)
	GUICtrlSetResizing($idQuit, $GUI_DOCKLEFT + $GUI_DOCKSIZE)

	Global $StatusMsg = GUICtrlCreateLabel("Status", 300, 375, 400, -1)
	GUICtrlSetResizing($StatusMsg, $GUI_DOCKLEFT + $GUI_DOCKSIZE)
	GUICtrlSetColor($StatusMsg, $COLOR_GREEN)
	GUICtrlSetState($StatusMsg, $GUI_HIDE)

	GUICtrlSetState($StatusMsg, $GUI_HIDE)

	GUISetState()

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $idQuit
				Exit
			Case $SkipPartialButton
				ExitLoop
			Case $SavePartialButton
				Local $SomethingWasChecked = "FALSE"
				For $i = 0 To UBound($PartialItemList) - 1
					If BitAND(GUICtrlRead($PartialItemList[$i], 1), $GUI_CHECKED) Then
						Local $SelectedMatch = StringTrimRight(GUICtrlRead($PartialItemList[$i]), 1)

						$RomNameClean = $ArrayToWorkOn[$i][0]
						$BestMatchNameCleaned = $ArrayToWorkOn[$i][1]
						$RomName = $ArrayToWorkOn[$i][2]
						$BestMatchName = $ArrayToWorkOn[$i][3]
						$bestMatch = $ArrayToWorkOn[$i][4]
						$NewName = $ArrayToWorkOn[$i][5]

						Local $DirOrFile = FileGetAttrib($SourceFolder & "\" & $BestMatchName)

						If StringInStr($DirOrFile, "D") Then
							If $Move = "TRUE" Then
								GUICtrlSetData($StatusMsg, "Moving Directory: " & $NewName)
								GUICtrlSetState($StatusMsg, $GUI_SHOW)
								AddToLog("Move DIR: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
								ConsoleWrite(StringFormat("Manual Move Dir: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
								If FileExists($SourceFolder & "\" & $BestMatchName) Then
									DirMove($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
								Else
									AddToLog($SourceFolder & "\" & $BestMatchName & " Dir no longer exists because it was moved previously. skipping.", $LogWindowDebug)
								EndIf
							Else
								GUICtrlSetData($StatusMsg, "Copying Directory: " & $NewName)
								GUICtrlSetState($StatusMsg, $GUI_SHOW)

								AddToLog("Copy DIR: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
								ConsoleWrite(StringFormat("Manual Copy Dir: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
								DirCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
							EndIf
						Else
							If $Move = "TRUE" Then
								GUICtrlSetData($StatusMsg, "Moving File: " & $NewName)
								GUICtrlSetState($StatusMsg, $GUI_SHOW)
								ConsoleWrite(StringFormat("Manual File copy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
								If FileExists($SourceFolder & "\" & $BestMatchName) Then
									AddToLog("Manual Move File: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
									FileMove($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
								Else
									AddToLog($SourceFolder & "\" & $BestMatchName & " File no longer exists because it was moved previously. skipping.", $LogWindowDebug)
								EndIf
							Else
								GUICtrlSetData($StatusMsg, "Copying File: " & $NewName)
								GUICtrlSetState($StatusMsg, $GUI_SHOW)
								AddToLog("Manual Copy File: " & $BestMatchName & " -> " & $NewName, $LogWindowDebug)
								ConsoleWrite(StringFormat("File Autocopy: " & $SourceFolder & "\" & $BestMatchName & "  ->  " & $DestinationFolder & "\" & $NewName & "\n"))
								FileCopy($SourceFolder & "\" & $BestMatchName, $DestinationFolder & "\" & $NewName)
							EndIf
						EndIf
						GUICtrlSetState($StatusMsg, $GUI_HIDE)
						$SomethingWasChecked = "TRUE"
					EndIf
				Next
				If $SomethingWasChecked = "FALSE" Then
					MsgBox(64, "Nothing checked", "If you found nothing you want matched here, click " & Chr(34) & "Skip" & Chr(34) & " instead.")
				Else
					ExitLoop
				EndIf
		EndSwitch
	WEnd
	GUIDelete($hGUI)
EndFunc   ;==>_RunManualCopy

Func _CleanName($Input)
	$Input = StringReplace($Input, "'", '') ; Removes '
	$Input = StringReplace($Input, '_', ' ') ; Change _ to ' '
	$Input = StringRegExpReplace($Input, '|', 'u') ; Change  to u

	$Input = StringReplace($Input, ' & ', ' and ') ; Change " & " to " and "

	$Input = StringRegExpReplace(" " & $Input & " ", ' [tT][hH][eE] ', ' ') ; Change " the " to " "

	$Input = StringRegExpReplace($Input, ' III | III,', ' 3 ') ; Changes " III " and " III," to " 3 "
	$Input = StringRegExpReplace($Input, ' II | II,', ' 2 ') ; Changes " II " and " II," to " 2 "
	$Input = StringRegExpReplace($Input, ' IV | IV,', ' 4 ') ; Changes " IV " and " IV," to " 4 "
	$Input = StringRegExpReplace($Input, ' VIII | VIII', ' 8 ') ; Changes " VIII " and " VIII," to " 8 "
	$Input = StringRegExpReplace($Input, ' VII | VII,', ' 7 ') ; Changes " VII " and " VII," to " 7 "
	$Input = StringRegExpReplace($Input, ' VI | VI,', ' 6 ') ; Changes " VI " and "VI," to " 6 "
	$Input = StringRegExpReplace($Input, ' V | V,', ' 5 ') ; Changes " V " and " VI," to " 5 "

	$Input = _FindDisks($Input) ; Go through the disc management function.

	$Input = StringRegExpReplace($Input, '\(.*\)', '') ; Removes (*)
	$Input = StringRegExpReplace($Input, '\[.*\]', '') ; Removes [*]

	$Input = StringRegExpReplace($Input, ' III$', ' 3') ; Changes " III." to " 3."
	$Input = StringRegExpReplace($Input, ' II$', ' 2') ; Changes " II." to " 2."
	$Input = StringRegExpReplace($Input, ' IV$', ' 4') ; Changes " IV." to " 4."
	$Input = StringRegExpReplace($Input, ' VIII$', ' 8') ; Changes " VIII." to " 8."
	$Input = StringRegExpReplace($Input, ' VII$', ' 7') ; Changes " VII." to " 7."
	$Input = StringRegExpReplace($Input, ' VI$', ' 6') ; Changes " VI." to " 6."
	$Input = StringRegExpReplace($Input, ' V$', ' 5') ; Changes " V." to " 5."

	$Input = StringRegExpReplace($Input, '\W', ' ') ; Removes All non ascii chars
	$Input = StringStripWS($Input, 7); Clean up extra whitespaces
	Return ($Input)
EndFunc   ;==>_CleanName

Func _FindDisks($testname)

	; Just return instantly if this function is not enabled.
	If $HandleDisks = "FALSE" Then
		Return ($testname)
	EndIf

	$testname = StringStripWS($testname, 7) ; Clean upp excess spaces.

	Local $TestNameArrayFinished[0] ; Initialize array

	$testnamearray = _StringBetween($testname, "(", ")") ; Convert the name to an array based on ()
	For $n = 0 To UBound($testnamearray) - 1 ; Go through it and add everything in it into the $TestNameArrayFinished array.
		_ArrayAdd($TestNameArrayFinished, $testnamearray[$n])
	Next
	$testnamearray = _StringBetween($testname, "[", "]") ; Do the same for everything inside []
	For $n = 0 To UBound($testnamearray) - 1
		_ArrayAdd($TestNameArrayFinished, $testnamearray[$n])
	Next

	If IsArray($TestNameArrayFinished) Then ; Safety check. Only do this if we actually got an array.
		For $n = 0 To UBound($TestNameArrayFinished) - 1 ; Go through the array of stuff contained inside () and []
			Local $FoundWithin = StringStripWS("(" & $TestNameArrayFinished[$n] & ")", 8) ; Strip away any white spaces.
			If StringRegExp($FoundWithin, "\([dD][iI][sS][kKcC]|\([tT][aA][pP][eE]|\([cC][aA][rR][tT]|\([sS][iI][dD][eE]") > 0 Then ; Does it contain any of this? Continue if so.
				Local $FoundWithinNumber = StringRegExpReplace($FoundWithin, "[^[:digit:]]", "") ; Strip away everything except for numbers.
				If $FoundWithinNumber <> "" Then ; Check if we got a number.
					$testname = $testname & $FoundWithinNumber ; Just add the number to the end of the name.
				EndIf
				If StringInStr($FoundWithin, "SideA)") Then ; Does it also contain SideA? If so ...
					$testname = $testname & "A" ; .. add an A after the number.
				ElseIf StringInStr($FoundWithin, "SideB)") Then ; Or if it contains SideB...
					$testname = $testname & "B" ; ... add a B after the number.
				EndIf
			EndIf
		Next

		Return $testname ; Return to whatever called me with the new name.
	Else
		Return ($testname) ; We never had an array to begin with. Strange but just return the name unmodified.
	EndIf
EndFunc   ;==>_FindDisks

Func RemoveExtRegExp($Input)
	Return StringRegExpReplace($Input, "\.[^.]*$", "")
EndFunc   ;==>RemoveExtRegExp

Func _FileGetExt($sPath)
	Local $NULL, $sExt
	_PathSplit($sPath, $NULL, $NULL, $NULL, $sExt)
	Return $sExt
EndFunc   ;==>_FileGetExt

; This function is called whenever you quit the script.
Func _Quit()
	Exit
EndFunc   ;==>_Quit
